#ifdef	ultrix	/* this file for Ultrix systems only */
# include	<sys/vm.h>
# include	"pmon.h"

#ifdef	SMASTER
#define	ULTRIX3
#endif	SMASTER

/*
** GETUPAGE - Reads the upage for the specified process as well as sufficient
** page tables entries for reading the command arguments. The pte's are read
** into the argument `ptetbl'. The upage is read into the external variable
** `User'. This procedure returns 1 if the upage was successfully read.
*/

#ifdef	vax
getupage ( p )

register struct proc		*p ;

{
	register int		i ;
	register int		ncl ;
	struct pte		pte ;
#ifdef	ULTRIX3
	struct pte	ptetbl[ UPAGES + CLSIZE ] ;
#else
	struct pte	ptetbl[ HIGHPAGES + CLSIZE ] ;
	register struct pte *pteaddr;
#endif	ULTRIX3

	/*
	 * If the process is not loaded, look for the upage
	 * on the swap device
	 */
#ifdef	ULTRIX3
	if ( !(p->p_flag & SLOAD) ) {
		lseek( swap, (long)dtob( p->p_swaddr ), 0 ) ;
#else
	if ( !(p->p_sched & SLOAD) ) {
		struct dmap l_dmap;
		int ublkno;

		lseek(kmem, (long)p->p_smap, 0);
		read(kmem, &l_dmap, sizeof(struct dmap));
		lseek(kmem, (long)l_dmap.dm_ptdaddr, 0);
		read(kmem, &ublkno, sizeof(ublkno));
		lseek(swap, (long)dtob(ublkno), 0);
#endif	ULTRIX3
		if ( read( swap, (char*)&user.user, sizeof( struct user ) )
		!= sizeof( struct user ) )
		{
			fprintf( stderr,
				"pmon - Can't read upage of process %d\n",
			    p->p_pid ) ;
			return ( 0 ) ;
		}
		return ( 1 ) ;		
	}				

	/*
	 * The process is loaded. Locate the process pte's by reading
	 *  the pte of their base address from system virtual address space.
	 */
	lseek( kmem, (long)&Usrptmap[ btokmx(p->p_p0br) + p->p_szpt-1 ], 0 ) ;
	if ( read( kmem, (char*)&pte, sizeof( struct pte ) )
	!= sizeof( struct pte ) )
	{
		fprintf( stderr,
		      "pmon - Can't read indir pte for upage of process %d\n",
		    p->p_pid ) ;
		return ( 0 ) ;
	}				
	/*
	 * Now read the process' pte's from physical memory. We need to access
	 * sufficient pte's for the upage and for the command arguments.
	 */
	lseek( mem, (long)ctob( pte.pg_pfnum+1 ) - sizeof(ptetbl), 0);
	if ( read( mem, (char*)ptetbl, sizeof(ptetbl) ) != sizeof(ptetbl) )
	{
		fprintf(stderr, "pmon - Can't read page table of process %d\n",
			p->p_pid ) ;
		return ( 0 ) ;
	}

	/*
	 * Now we can read the pages belonging to the upage.
	 * Here we read in an entire click at one go.
	 */
	ncl = (sizeof( struct user ) + NBPG*CLSIZE - 1) / (NBPG*CLSIZE) ;
#ifdef	ULTRIX3
	while ( --ncl >= 0 )		
	{				
		i = ncl * CLSIZE ;
		lseek( mem, (long)ctob( ptetbl[ CLSIZE+i ].pg_pfnum ), 0 ) ;
		if ( read( mem, user.upages[i], CLSIZE*NBPG ) != CLSIZE*NBPG )
		{
			fprintf( stderr,
				"pmon - Can't read page 0x%x of process %d\n",
				ptetbl[ CLSIZE+i ].pg_pfnum, p->p_pid ) ;
			return ( 0 ) ;
		}
	}
#else
	for (pteaddr = &ptetbl[UPAGES + ncl*CLSIZE];
	     pteaddr > &ptetbl[UPAGES];
	     pteaddr -= CLSIZE) {
		lseek(mem, (long)ctob(pteaddr->pg_pfnum), 0);
		if (read(mem,
			 user.upages[pteaddr - &ptetbl[CLSIZE + UPAGES]],
			 CLSIZE*NBPG)
		  != CLSIZE*NBPG) {
			fprintf( stderr,
				"pmon - Can't read page 0x%x of process %d\n",
				pteaddr->pg_pfnum, p->p_pid ) ;
		    return(0);
		}
	}
#endif	ULTRIX3

	return ( 1 ) ;
}

#else	/* MIPS/Ultrix */

getupage ( p )

register struct proc		*p ;

{
	register int		i ;
	register int		ncl ;
	struct pte		pte ;
	register struct pte *pteaddr;
#ifdef	ULTRIX3
	struct pte	ptetbl[ CLSIZE ] ;
#else
	struct pte	ptetbl[ HIGHPAGES + CLSIZE ] ;
#endif	ULTRIX3
	struct pte wpte[UPAGES];
	long off;

	/*
	 * If the process is not loaded, look for the upage
	 * on the swap device
	 */
#ifdef	ULTRIX3
	if ( !(p->p_flag & SLOAD) ) {
		lseek( swap, (long)dtob( p->p_swaddr ), 0 ) ;
#else
	if ( !(p->p_sched & SLOAD) ) {
		struct dmap l_dmap;
		int ublkno;

		lseek(kmem, (long)p->p_smap, 0);
		read(kmem, &l_dmap, sizeof(struct dmap));
		lseek(kmem, (long)l_dmap.dm_ptdaddr, 0);
		read(kmem, &ublkno, sizeof(ublkno));
		lseek(swap, (long)dtob(ublkno), 0);
#endif	ULTRIX3
		if ( read( swap, (char*)&user.user, sizeof( struct user ) )
		!= sizeof( struct user ) )
		{
			fprintf( stderr,
				"pmon - Can't read upage of process %d\n",
			    p->p_pid ) ;
			return ( 0 ) ;
		}
		return ( 1 ) ;		
	}				

	/*
	 * The process is loaded. Locate the process pte's by reading
	 *  the pte of their base address from system virtual address space.
	 */
#ifdef	ULTRIX3
	if ((p->p_flag & SSYS) == 0) {
#else
	if ((p->p_type & SSYS) == 0) {
#endif	ULTRIX3
	    lseek(kmem, (long)&Usrptmap[btokmx(p->p_stakbr)+p->p_stakpt-1], 0);
	    if ( read( kmem, (char*)&pte, sizeof( struct pte ) )
	    != sizeof( struct pte ) )
	    {
		fprintf( stderr,
		      "pmon - Can't read indir pte for upage of process %d\n",
		    p->p_pid ) ;
		return ( 0 ) ;
	    }				
	    /*
	     * Now read the process' pte's from physical memory.
	     * We need to access
	     * sufficient pte's for the upage and for the command arguments.
	     */
	    off = (long)ctob(pte.pg_pfnum) + NBPG 
#ifdef	ULTRIX3
		    - ((REDZONEPAGES+1) * sizeof(struct pte));
#else
		    - ((HIGHPAGES+1) * sizeof(struct pte));
#endif	ULTRIX3
	    lseek( mem, off, 0);
	    if (read( mem, (char*)ptetbl, sizeof(ptetbl) ) != sizeof(ptetbl) )
	    {
		fprintf(stderr, "pmon - Can't read page table of process %d\n",
			p->p_pid ) ;
		return ( 0 ) ;
	    }
	}

	lseek(kmem, (long)p->p_addr, 0);
	if (read(kmem, (char *)wpte, sizeof(wpte)) != sizeof(wpte)) {
		fprintf( stderr,
		      "pmon - Can't read indir pte to get u of process %d\n",
		    p->p_pid ) ;
		return ( 0 ) ;
	}
	/*
	 * Now we can read the pages belonging to the upage.
	 * Here we read in an entire click at one go.
	 */

	ncl = (sizeof( struct user ) + NBPG*CLSIZE - 1) / (NBPG*CLSIZE) ;
	while ( --ncl >= 0 )		
	{				
		i = ncl * CLSIZE ;
		lseek( mem, (long)ctob( wpte[i].pg_pfnum ), 0 ) ;
		if ( read( mem, user.upages[i], CLSIZE*NBPG ) != CLSIZE*NBPG )
		{
			fprintf( stderr,
				"pmon - Can't read page 0x%x of process %d\n",
				wpte[i].pg_pfnum, p->p_pid ) ;
			return ( 0 ) ;
		}
	}
	return ( 1 ) ;
}
#endif	vax
#endif	ultrix	/* this file for Ultrix systems only */
